Index: binaries/data/mods/public/globalscripts/Templates.js
===================================================================
--- binaries/data/mods/public/globalscripts/Templates.js
+++ binaries/data/mods/public/globalscripts/Templates.js
@@ -251,6 +251,7 @@ function GetTemplateDataHelper(template, player)
 			"templates": {
 				"tower": template.WallSet.Templates.Tower,
 				"gate": template.WallSet.Templates.Gate,
+				"fort": template.WallSet.Templates.Fort || "structures/{civ}_fortress",
 				"long": template.WallSet.Templates.WallLong,
 				"medium": template.WallSet.Templates.WallMedium,
 				"short": template.WallSet.Templates.WallShort,
@@ -258,10 +259,21 @@ function GetTemplateDataHelper(template, player)
 			"maxTowerOverlap": +template.WallSet.MaxTowerOverlap,
 			"minTowerOverlap": +template.WallSet.MinTowerOverlap,
 		};
+		if (template.WallSet.Templates.WallEnd)
+			ret.wallSet.templates.end = template.WallSet.Templates.WallEnd;
+		if (template.WallSet.Templates.WallCurveQuarter)
+			ret.wallSet.templates.quarterCurve = template.WallSet.Templates.WallCurveQuarter;
+		if (template.WallSet.Templates.WallCurveEighth)
+			ret.wallSet.templates.eighthCurve = template.WallSet.Templates.WallCurveEighth;
 	}
 
 	if (template.WallPiece)
-		ret.wallPiece = {"length": +template.WallPiece.Length};
+		ret.wallPiece = {
+			"length": +template.WallPiece.Length,
+			"angle": +(template.WallPiece.Orientation || 1) * Math.PI,
+			"indent": +(template.WallPiece.Indent || 0),
+			"bend": +(template.WallPiece.Bend || 0) * Math.PI,
+		};
 
 	return ret;
 }
Index: binaries/data/mods/public/maps/random/belgian_uplands.js
===================================================================
--- binaries/data/mods/public/maps/random/belgian_uplands.js
+++ binaries/data/mods/public/maps/random/belgian_uplands.js
@@ -21,10 +21,6 @@ var mapSize = getMapSize();
 // Heightmap functionality
 //////////
 
-// Some general heightmap settings
-const MIN_HEIGHT = - SEA_LEVEL; // 20, should be set in the libs!
-const MAX_HEIGHT = 0xFFFF/HEIGHT_UNITS_PER_METRE - SEA_LEVEL; // A bit smaler than 90, should be set in the libs!
-
 // Add random heightmap generation functionality
 function getRandomReliefmap(minHeight, maxHeight)
 {
@@ -35,10 +31,10 @@ function getRandomReliefmap(minHeight, maxHeight)
 	if (maxHeight > MAX_HEIGHT)
 		warn("getRandomReliefmap: Argument maxHeight is smaler then the supported maximum height of " + MAX_HEIGHT + " (const MAX_HEIGHT): " + maxHeight)
 	var reliefmap = [];
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
 		reliefmap.push([]);
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			reliefmap[x].push(randFloat(minHeight, maxHeight));
 		}
@@ -50,9 +46,9 @@ function getRandomReliefmap(minHeight, maxHeight)
 function setReliefmap(reliefmap)
 {
 	// g_Map.height = reliefmap;
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			setHeight(x, y, reliefmap[x][y]);
 		}
@@ -65,9 +61,9 @@ function getMinAndMaxHeight(reliefmap)
 	var height = {};
 	height.min = Infinity;
 	height.max = -Infinity;
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			if (reliefmap[x][y] < height.min)
 				height.min = reliefmap[x][y];
@@ -89,9 +85,9 @@ function getRescaledReliefmap(reliefmap, minHeight, maxHeight)
 	if (maxHeight > MAX_HEIGHT)
 		warn("getRescaledReliefmap: Argument maxHeight is smaler then the supported maximum height of " + MAX_HEIGHT + " (const MAX_HEIGHT): " + maxHeight)
 	var oldHeightRange = getMinAndMaxHeight(reliefmap);
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			newReliefmap[x][y] = minHeight + (reliefmap[x][y] - oldHeightRange.min) / (oldHeightRange.max - oldHeightRange.min) * (maxHeight - minHeight);
 		}
@@ -105,12 +101,12 @@ function getHeightErrosionedReliefmap(reliefmap, strength)
 	var newReliefmap = deepcopy(reliefmap);
 	strength = (strength || 1.0); // Values much higher then 1 (1.32+ for an 8 tile map, 1.45+ for a 12 tile map, 1.62+ @ 20 tile map, 0.99 @ 4 tiles) will result in a resonance disaster/self interference
 	var map = [[1, 0], [1, 1], [0, 1], [-1, 1], [-1, 0], [-1, -1], [0, -1], [1, -1]]; // Default
-	for (var x = 0; x <= mapSize; x++)
+	for (var x = 0; x <= mapSize; ++x)
 	{
-		for (var y = 0; y <= mapSize; y++)
+		for (var y = 0; y <= mapSize; ++y)
 		{
 			var div = 0;
-			for (var i = 0; i < map.length; i++)
+			for (var i = 0; i < map.length; ++i)
 				newReliefmap[x][y] += strength / map.length * (reliefmap[(x + map[i][0] + mapSize + 1) % (mapSize + 1)][(y + map[i][1] + mapSize + 1) % (mapSize + 1)] - reliefmap[x][y]); // Not entirely sure if scaling with map.length is perfect but tested values seam to indicate it is
 		}
 	}
@@ -173,7 +169,7 @@ var terreins = ["temp_grass_plants|gaia/flora_tree_euro_beech", "temp_grass_moss
 	"temp_grass_long|gaia/flora_tree_apple", "temp_grass_clovers|gaia/flora_bush_berry", "temp_grass_clovers_2|gaia/flora_bush_grapes",
 	"temp_grass_plants|gaia/fauna_deer", "temp_grass_long_b|gaia/fauna_rabbit"];
 var numTerreins = terreins.length;
-for (var i = 0; i < numTerreins; i++)
+for (var i = 0; i < numTerreins; ++i)
 	terreins.push("temp_grass_plants");
 textueByHeight.push({"upperHeightLimit": waterHeightAdjusted + 5/6 * (heightRange.max - waterHeightAdjusted), "terrain": terreins});
 // Unpassable woods
@@ -200,11 +196,11 @@ var enoughTiles = false;
 var tries = 0;
 while (!goodStartPositionsFound)
 {
-	tries++;
+	++tries;
 	log("Starting giant while loop try " + tries);
 	// Generate reliefmap
 	var myReliefmap = getRandomReliefmap(heightRange.min, heightRange.max);
-	for (var i = 0; i < 50 + mapSize/4; i++) // Cycles depend on mapsize (more cycles -> bigger structures)
+	for (var i = 0; i < 50 + mapSize/4; ++i) // Cycles depend on mapsize (more cycles -> bigger structures)
 		myReliefmap = getHeightErrosionedReliefmap(myReliefmap, 1);
 	myReliefmap = getRescaledReliefmap(myReliefmap, heightRange.min, heightRange.max);
 	setReliefmap(myReliefmap);
@@ -217,18 +213,18 @@ while (!goodStartPositionsFound)
 	var lowerHeightLimit = textueByHeight[3].upperHeightLimit;
 	var upperHeightLimit = textueByHeight[6].upperHeightLimit;
 	// Check for valid points by height
-	for (var x = distToBorder + minTerrainDistToBorder; x < mapSize - distToBorder - minTerrainDistToBorder; x++)
+	for (var x = distToBorder + minTerrainDistToBorder; x < mapSize - distToBorder - minTerrainDistToBorder; ++x)
 	{
-		for (var y = distToBorder + minTerrainDistToBorder; y < mapSize - distToBorder - minTerrainDistToBorder; y++)
+		for (var y = distToBorder + minTerrainDistToBorder; y < mapSize - distToBorder - minTerrainDistToBorder; ++y)
 		{
 			var actualHeight = getHeight(x, y);
 			if (actualHeight > lowerHeightLimit && actualHeight < upperHeightLimit)
 			{
 				// Check for points within a valid area by height (rectangular since faster)
 				var isPossible = true;
-				for (var offX = - neededDistance; offX <= neededDistance; offX++)
+				for (var offX = - neededDistance; offX <= neededDistance; ++offX)
 				{
-					for (var offY = - neededDistance; offY <= neededDistance; offY++)
+					for (var offY = - neededDistance; offY <= neededDistance; ++offY)
 					{
 						var testHeight = getHeight(x + offX, y + offY);
 						if (testHeight <= lowerHeightLimit || testHeight >= upperHeightLimit)
@@ -252,7 +248,7 @@ while (!goodStartPositionsFound)
 	// Reduce to tiles in a circle of mapSize / 2 distance to the center (to avoid players placed in corners)
 	var possibleStartPositionsTemp = [];
 	var maxDistToCenter = mapSize / 2;
-	for (var i = 0; i < possibleStartPositions.length; i++)
+	for (var i = 0; i < possibleStartPositions.length; ++i)
 	{
 		var deltaX = possibleStartPositions[i][0] - mapSize / 2;
 		var deltaY = possibleStartPositions[i][1] - mapSize / 2;
@@ -270,19 +266,19 @@ while (!goodStartPositionsFound)
 	var maxDistToResources = distToBorder; // Has to be <= distToBorder!
 	var minNumLowTiles = 10;
 	var minNumHighTiles = 10;
-	for (var i = 0; i < possibleStartPositions.length; i++)
+	for (var i = 0; i < possibleStartPositions.length; ++i)
 	{
 		var numLowTiles = 0;
 		var numHighTiles = 0;
-		for (var dx = - maxDistToResources; dx < maxDistToResources; dx++)
+		for (var dx = - maxDistToResources; dx < maxDistToResources; ++dx)
 		{
-			for (var dy = - maxDistToResources; dy < maxDistToResources; dy++)
+			for (var dy = - maxDistToResources; dy < maxDistToResources; ++dy)
 			{
 				var testHeight = getHeight(possibleStartPositions[i][0] + dx, possibleStartPositions[i][1] + dy);
 				if (testHeight < lowerHeightLimit)
-					numLowTiles++;
+					++numLowTiles;
 				if (testHeight > upperHeightLimit)
-					numHighTiles++;
+					++numHighTiles;
 				if (numLowTiles > minNumLowTiles && numHighTiles > minNumHighTiles)
 					break;
 			}
@@ -311,22 +307,22 @@ while (!goodStartPositionsFound)
 		// Get some random start location derivations. NOTE: Itterating over all possible derivations is just to much (valid points ** numPlayers)
 		var maxTries = 100000; // floor(800000 / (Math.pow(numPlayers, 2) / 2));
 		var possibleDerivations = [];
-		for (var i = 0; i < maxTries; i++)
+		for (var i = 0; i < maxTries; ++i)
 		{
 			var vector = [];
-			for (var p = 0; p < numPlayers; p++)
+			for (var p = 0; p < numPlayers; ++p)
 				vector.push(randInt(possibleStartPositions.length));
 			possibleDerivations.push(vector);
 		}
 		
 		// Choose the start location derivation with the greatest minimum distance between players
 		var maxMinDist = 0;
-		for (var d = 0; d < possibleDerivations.length; d++)
+		for (var d = 0; d < possibleDerivations.length; ++d)
 		{
 			var minDist = 2 * mapSize;
-			for (var p1 = 0; p1 < numPlayers - 1; p1++)
+			for (var p1 = 0; p1 < numPlayers - 1; ++p1)
 			{
-				for (var p2 = p1 + 1; p2 < numPlayers; p2++)
+				for (var p2 = p1 + 1; p2 < numPlayers; ++p2)
 				{
 					if (p1 != p2)
 					{
@@ -372,12 +368,12 @@ if (mapSize > 500)
 	propDensity = 1/4;
 else if (mapSize > 400)
 	propDensity = 3/4;
-for(var x = minTerrainDistToBorder; x < mapSize - minTerrainDistToBorder; x++)
+for(var x = minTerrainDistToBorder; x < mapSize - minTerrainDistToBorder; ++x)
 {
-	for (var y = minTerrainDistToBorder; y < mapSize - minTerrainDistToBorder; y++)
+	for (var y = minTerrainDistToBorder; y < mapSize - minTerrainDistToBorder; ++y)
 	{
 		var textureMinHeight = heightRange.min;
-		for (var i = 0; i < textueByHeight.length; i++)
+		for (var i = 0; i < textueByHeight.length; ++i)
 		{
 			if (getHeight(x, y) >= textureMinHeight && getHeight(x, y) <= textueByHeight[i].upperHeightLimit)
 			{
@@ -497,7 +493,7 @@ RMS.SetProgress(90);
 // Place players and start resources
 ////////
 
-for (var p = 0; p < numPlayers; p++)
+for (var p = 0; p < numPlayers; ++p)
 {
 	var actualX = possibleStartPositions[bestDerivation[p]][0];
 	var actualY = possibleStartPositions[bestDerivation[p]][1];
@@ -509,7 +505,7 @@ for (var p = 0; p < numPlayers; p++)
 	{
 		var uAngle = BUILDING_ANGlE - PI * (2-j) / 2;
 		var count = 4;
-		for (var numberofentities = 0; numberofentities < count; numberofentities++)
+		for (var numberofentities = 0; numberofentities < count; ++numberofentities)
 		{
 			var ux = actualX + uDist * cos(uAngle) + numberofentities * uSpace * cos(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * cos(uAngle + PI/2));
 			var uz = actualY + uDist * sin(uAngle) + numberofentities * uSpace * sin(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * sin(uAngle + PI/2));
@@ -531,7 +527,7 @@ timeArray.push(new Date().getTime());
 // Calculate progress percentage with the time checks
 var generationTime = timeArray[timeArray.length - 1] - timeArray[0];
 log("Total generation time (ms): " + generationTime);
-for (var i = 0; i < timeArray.length; i++)
+for (var i = 0; i < timeArray.length; ++i)
 {
 	var timeSinceStart = timeArray[i] - timeArray[0];
 	var progressPercentage = 100 * timeSinceStart / generationTime;
Index: binaries/data/mods/public/maps/random/rmgen/library.js
===================================================================
--- binaries/data/mods/public/maps/random/rmgen/library.js
+++ binaries/data/mods/public/maps/random/rmgen/library.js
@@ -4,14 +4,24 @@
 /////////////////////////////////////////////////////////////////////////////////////////////
 
 const PI = Math.PI;
-const TWO_PI = 2 * Math.PI;
+const TWO_PI = 2 * Math.PI; // mathematically known as 'tau'
 const TERRAIN_SEPARATOR = "|";
-const SEA_LEVEL = 20.0;
+const SEA_LEVEL = 160.0;
 const CELL_SIZE = 4;
 const HEIGHT_UNITS_PER_METRE = 92;
 const MIN_MAP_SIZE = 128;
 const MAX_MAP_SIZE = 512;
 const FALLBACK_CIV = "athen";
+// Constants needed for heightmap_manipulation.js
+const MAX_HEIGHT_RANGE = 0xFFFF / HEIGHT_UNITS_PER_METRE // Engine limit, Roughly 700 meters
+const MIN_HEIGHT = - SEA_LEVEL;
+const MAX_HEIGHT = MAX_HEIGHT_RANGE - SEA_LEVEL;
+// Entity template structure keys that might change, for easier mod support
+const STARTING_ENTITY_KEY = "StartEntities";
+const START_ENTITY_TEMPLATE_PATH_KEY = "Template"
+const BUILDER_TEMPLATEPATH_KEYS = ["Builder", "Entities", "_string"];
+const PRODUCTION_TEMPLATEPATH_KEYS = ["ProductionQueue", "Entities", "_string"];
+const CIV_PLACEHOLDER_STRING = "{civ}";
 
 /////////////////////////////////////////////////////////////////////////////////////////////
 //	Utility functions
@@ -103,7 +113,7 @@ function argsToArray(x)
 	if (numArgs != 1)
 	{
 		var ret = new Array(numArgs);
-		for (var i=0; i < numArgs; i++)
+		for (var i=0; i < numArgs; ++i)
 		{
 			ret[i] = x[i];
 		}
@@ -132,7 +142,7 @@ function shuffleArray(source)
 		return [];
 
 	var result = [source[0]];
-	for (var i = 1; i < source.length; i++)
+	for (var i = 1; i < source.length; ++i)
 	{
 		var j = randInt(0, i);
 		result[i] = result[j];
@@ -172,12 +182,12 @@ function createAreas(centeredPlacer, painter, constraint, num, retryFactor)
 		var area = g_Map.createArea(centeredPlacer, painter, constraint);
 		if (area !== undefined)
 		{
-			good++;
+			++good;
 			result.push(area);
 		}
 		else
 		{
-			bad++;
+			++bad;
 		}
 	}
 	return result;
@@ -208,12 +218,12 @@ function createAreasInAreas(centeredPlacer, painter, constraint, num, retryFacto
 		var area = g_Map.createArea(centeredPlacer, painter, constraint);
 		if (area !== undefined)
 		{
-			good++;
+			++good;
 			result.push(area);
 		}
 		else
 		{
-			bad++;
+			++bad;
 		}
 	}
 	return result;
@@ -248,11 +258,11 @@ function createObjectGroups(placer, player, constraint, num, retryFactor)
 		var result = createObjectGroup(placer, player, constraint);
 		if (result !== undefined)
 		{
-			good++;
+			++good;
 		}
 		else
 		{
-			bad++;
+			++bad;
 		}
 	}
 	return good;
@@ -282,11 +292,11 @@ function createObjectGroupsByAreas(placer, player, constraint, num, retryFactor,
 		var result = createObjectGroup(placer, player, constraint);
 		if (result !== undefined)
 		{
-			good++;
+			++good;
 		}
 		else
 		{
-			bad++;
+			++bad;
 		}
 	}
 	return good;
@@ -394,15 +404,111 @@ function getNumPlayers()
 	return g_MapSettings.PlayerData.length - 1;
 }
 
+// Takes nothing, returns an array of strings representing all available civilizations
+function getCivList()
+{
+	var raw_civData = RMS.GetCivData();
+	var civList = [];
+	for (var i = 0; i < raw_civData.length; ++i)
+		civList.push(JSON.parse(raw_civData[i]).Code);
+	
+	return civList;
+}
+
+// Takes nothing, returns an associative array with civ strings as keys containing all unpacked civ data (Templates need to be unpacked with RMS.GetTemplate() if needed)
+function getFullCivData()
+{
+	var rawCivData = RMS.GetCivData();
+	var unpackedCivData = {};
+	for (var i = 0; i < rawCivData.length; ++i)
+	{
+		var singleCivData = JSON.parse(rawCivData[i]);
+		unpackedCivData[singleCivData.Code] = singleCivData;
+	}
+	
+	return unpackedCivData;
+}
+
+// Takes a player number (0-7, so Gaia excluded). Returns this players civ string
+// ToDo: If the player number is to high an error will occur (and the fallback won't be reached)!
 function getCivCode(player)
 {
 	if (g_MapSettings.PlayerData[player+1].Civ)
 		return g_MapSettings.PlayerData[player+1].Civ;
 
-	warn("undefined civ specified for player " + (player + 1) + ", falling back to '" + FALLBACK_CIV + "'");
+	warn("Undefined civ specified for player " + (player + 1) + ", falling back to '" + FALLBACK_CIV + "'");
 	return FALLBACK_CIV;
 }
 
+// Takes an entity path and a key list to get the templates value
+function getTemplateValue(entPath, key_list)
+{
+	var subdata = RMS.GetTemplate(entPath);
+	for (var i = 0; i < key_list.length; ++i)
+	{
+		if (!subdata[key_list[i]])
+			{return false};
+		subdata = subdata[key_list[i]];
+	}
+	return subdata;
+}
+
+// Returns a list of all templates paths available to the given civ
+function getTempatePathList(civ)
+{
+	var templatePaths = getFullCivData();
+	if (!templatePaths[civ])
+	{
+		warn("getTempatePathList: Unknown civ '" + civ + "' not in " + Object.keys(templatePaths));
+		return false;
+	}
+	templatePaths = templatePaths[civ];
+	
+	if (!templatePaths[STARTING_ENTITY_KEY])
+	{
+		warn("getTempatePathList: Civ has no starting entities as defined in STARTING_ENTITY_KEY (" + STARTING_ENTITY_KEY + "): " + Object.keys(templatePaths));
+		return false;
+	}
+	templatePaths = templatePaths[STARTING_ENTITY_KEY];
+	
+	for (var i = 0; i < templatePaths.length; ++i)
+	{
+		if (!templatePaths[i][START_ENTITY_TEMPLATE_PATH_KEY])
+		{
+			warn("getTempatePathList: Starting entity list item has no template as defined in START_ENTITY_TEMPLATE_PATH_KEY (" + START_ENTITY_TEMPLATE_PATH_KEY + "): " + Object.keys(templatePaths));
+			return false;
+		}
+		templatePaths[i] = templatePaths[i][START_ENTITY_TEMPLATE_PATH_KEY];
+	}
+	var foundNew = 1;
+	while (foundNew > 0)
+	{
+		foundNew = 0;
+		var methods = [BUILDER_TEMPLATEPATH_KEYS, PRODUCTION_TEMPLATEPATH_KEYS];
+		for (var m = 0; m < methods.length; ++m)
+		{
+			for (var t = 0; t < templatePaths.length; ++t)
+			{
+				var pathsToCheck = getTemplateValue(templatePaths[t], methods[m]);
+				if (typeof(pathsToCheck) === typeof(""))
+				{
+					pathsToCheck = pathsToCheck.split(/\s+/);
+					for (var c = 0; c < pathsToCheck.length; ++c)
+					{
+						var actualPath = pathsToCheck[c].replace(CIV_PLACEHOLDER_STRING, civ);
+						if (templatePaths.indexOf(actualPath) == -1 && RMS.TemplateExists(actualPath))
+						{
+							templatePaths.push(actualPath);
+							++foundNew;
+						}
+					}
+				}
+			}
+		}
+	}
+	return templatePaths;
+}
+
 function areAllies(player1, player2)
 {
 	if ((g_MapSettings.PlayerData[player1+1].Team === undefined) || (g_MapSettings.PlayerData[player2+1].Team === undefined) || (g_MapSettings.PlayerData[player2+1].Team == -1) || (g_MapSettings.PlayerData[player1+1].Team == -1))
@@ -434,14 +540,14 @@ function sortPlayers(source)
 
 	var result = new Array(0);
 	var team = new Array(5);
-	for (var q = 0; q < 5; q++)
+	for (var q = 0; q < 5; ++q)
 	{
 		team[q] = new Array(1);
 	}
 
-	for (var i = -1; i < 4; i++)
+	for (var i = -1; i < 4; ++i)
 	{
-		for (var j = 0; j < source.length; j++)
+		for (var j = 0; j < source.length; ++j)
 		{
 			if (getPlayerTeam(j) == i)
 			{
@@ -461,7 +567,7 @@ function primeSortPlayers(source)
 
 	var prime = new Array(source.length);
 
-	for (var i = 0; i < round(source.length/2); i++)
+	for (var i = 0; i < round(source.length/2); ++i)
 	{
 		prime[2*i]=source[i];
 		prime[2*i+1]=source[source.length-1-i];
@@ -535,7 +641,7 @@ function unPaintClass(id)
 function avoidClasses(/*class1, dist1, class2, dist2, etc*/)
 {
 	var ar = new Array(arguments.length/2);
-	for (var i = 0; i < arguments.length/2; i++)
+	for (var i = 0; i < arguments.length/2; ++i)
 	{
 		ar[i] = new AvoidTileClassConstraint(arguments[2*i], arguments[2*i+1]);
 	}
@@ -555,7 +661,7 @@ function avoidClasses(/*class1, dist1, class2, dist2, etc*/)
 function stayClasses(/*class1, dist1, class2, dist2, etc*/)
 {
 	var ar = new Array(arguments.length/2);
-	for (var i = 0; i < arguments.length/2; i++)
+	for (var i = 0; i < arguments.length/2; ++i)
 	{
 		ar[i] = new StayInTileClassConstraint(arguments[2*i], arguments[2*i+1]);
 	}
@@ -575,7 +681,7 @@ function stayClasses(/*class1, dist1, class2, dist2, etc*/)
 function borderClasses(/*class1, idist1, odist1, class2, idist2, odist2, etc*/)
 {
 	var ar = new Array(arguments.length/3);
-	for (var i = 0; i < arguments.length/3; i++)
+	for (var i = 0; i < arguments.length/3; ++i)
 	{
 		ar[i] = new BorderTileClassConstraint(arguments[3*i], arguments[3*i+1], arguments[3*i+2]);
 	}
@@ -642,4 +748,3 @@ function getTerrainTexture(x, y)
 {
 	return g_Map.getTexture(x, y);
 }
-
Index: binaries/data/mods/public/maps/random/rmgen/misc.js
===================================================================
--- binaries/data/mods/public/maps/random/rmgen/misc.js
+++ binaries/data/mods/public/maps/random/rmgen/misc.js
@@ -20,9 +20,9 @@ function passageMaker(x1, z1, x2, z2, width, maxheight, height, smooth, tileclas
 	var tchm = TILE_CENTERED_HEIGHT_MAP;
 	TILE_CENTERED_HEIGHT_MAP = true;
 	var mapSize = g_Map.size;
-	for (var ix = 0; ix < mapSize; ix++)
+	for (var ix = 0; ix < mapSize; ++ix)
 	{
-		for (var iz = 0; iz < mapSize; iz++)
+		for (var iz = 0; iz < mapSize; ++iz)
 		{
 			var a = z1-z2;
 			var b = x2-x1;
@@ -92,7 +92,7 @@ function rndRiver(f, seed)
 	var rndRe = 0;
 	var rndRr = f-floor(f);
 	var rndRa = 0;
-	for (var rndRx=0; rndRx<=floor(f); rndRx++)
+	for (var rndRx=0; rndRx<=floor(f); ++rndRx)
 	{
 		rndRw = 10*(rndRw-floor(rndRw));
 	}
@@ -148,7 +148,7 @@ function createStartingPlayerEntities(fx, fz, playerid, civEntities, BUILDING_AN
 	{
 		var uAngle = BUILDING_ANGlE - PI * (2-j) / 2;
 		var count = (civEntities[j].Count !== undefined ? civEntities[j].Count : 1);
-		for (var numberofentities = 0; numberofentities < count; numberofentities++)
+		for (var numberofentities = 0; numberofentities < count; ++numberofentities)
 		{
 			var ux = fx + uDist * cos(uAngle) + numberofentities * uSpace * cos(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * cos(uAngle + PI/2));
 			var uz = fz + uDist * sin(uAngle) + numberofentities * uSpace * sin(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * sin(uAngle + PI/2));
@@ -157,17 +157,17 @@ function createStartingPlayerEntities(fx, fz, playerid, civEntities, BUILDING_AN
 	}
 }
 
-//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 // placeCivDefaultEntities
 //
 //	Creates the default starting player entities depending on the players civ
 //	fx&fy: position of player base
 //	playerid: id of player
 //	angle: angle of main base building, optional, default is BUILDING_ANGlE
-//	kwargs: Takes some optional keyword arguments to tweek things
-//		'iberWall': may be false, 'walls' (default) or 'towers'. Determines the defensive structures Iberians get as civ bonus
+//	kwargs: Optional. Takes an associative array with keyword arguments to tweak things:
+//		Known keys: 'iberWall': may be false, 'walls' (default) or 'towers'. Determines the defensive structures Iberians get as civ bonus
 //
-//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
+//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 function placeCivDefaultEntities(fx, fz, playerid, angle, kwargs)
 {
 	// Unpack kwargs
@@ -187,7 +187,7 @@ function placeCivDefaultEntities(fx, fz, playerid, angle, kwargs)
 	{
 		var uAngle = angle - PI * (2-j) / 2;
 		var count = (civEntities[j].Count !== undefined ? civEntities[j].Count : 1);
-		for (var numberofentities = 0; numberofentities < count; numberofentities++)
+		for (var numberofentities = 0; numberofentities < count; ++numberofentities)
 		{
 			var ux = fx + uDist * cos(uAngle) + numberofentities * uSpace * cos(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * cos(uAngle + PI/2));
 			var uz = fz + uDist * sin(uAngle) + numberofentities * uSpace * sin(uAngle + PI/2) - (0.75 * uSpace * floor(count / 2) * sin(uAngle + PI/2));
@@ -221,9 +221,9 @@ function placeCivDefaultEntities(fx, fz, playerid, angle, kwargs)
 function paintTerrainBasedOnHeight(minheight, maxheight, mode, terrain)
 {
 	var mSize = g_Map.size;
-	for (var qx = 0; qx < mSize; qx++)
+	for (var qx = 0; qx < mSize; ++qx)
 	{
-		for (var qz = 0; qz < mSize; qz++)
+		for (var qz = 0; qz < mSize; ++qz)
 		{
 			if (mode == 0)
 			{
@@ -273,9 +273,9 @@ function paintTerrainBasedOnHeight(minheight, maxheight, mode, terrain)
 function paintTileClassBasedOnHeight(minheight, maxheight, mode, tileclass)
 {
 	var mSize = g_Map.size;
-	for (var qx = 0; qx < mSize; qx++)
+	for (var qx = 0; qx < mSize; ++qx)
 	{
-		for (var qz = 0; qz < mSize; qz++)
+		for (var qz = 0; qz < mSize; ++qz)
 		{
 			if (mode == 0)
 			{
@@ -313,9 +313,9 @@ function paintTileClassBasedOnHeight(minheight, maxheight, mode, tileclass)
 function unPaintTileClassBasedOnHeight(minheight, maxheight, mode, tileclass)
 {
 	var mSize = g_Map.size;
-	for (var qx = 0; qx < mSize; qx++)
+	for (var qx = 0; qx < mSize; ++qx)
 	{
-		for (var qz = 0; qz < mSize; qz++)
+		for (var qz = 0; qz < mSize; ++qz)
 		{
 			if (mode == 0)
 			{
@@ -617,7 +617,7 @@ function createMountain(maxHeight, minRadius, maxRadius, numCircles, constraint,
 		
 		for (var ix = sx; ix <= lx; ++ix)
 		{
-			for (var iz = sz; iz <= lz; ++ iz)
+			for (var iz = sz; iz <= lz; ++iz)
 			{
 				dx = ix - cx;
 				dz = iz - cz;
@@ -666,7 +666,7 @@ function createMountain(maxHeight, minRadius, maxRadius, numCircles, constraint,
 		
 		for (var ix = sx; ix <= lx; ++ix)
 		{
-			for (var iz = sz; iz <= lz; ++ iz)
+			for (var iz = sz; iz <= lz; ++iz)
 			{
 				if (fcc)
 					if ((x - ix) > fcc || (ix - x) > fcc || (z - iz) > fcc || (iz - z) > fcc)
@@ -737,7 +737,7 @@ function createMountain(maxHeight, minRadius, maxRadius, numCircles, constraint,
 		
 		for (var ix = sx; ix <= lx; ++ix)
 		{
-			for (var iz = sz; iz <= lz; ++ iz)
+			for (var iz = sz; iz <= lz; ++iz)
 			{
 				dx = ix - cx;
 				dz = iz - cz;
